#pragma once

#include "OpenGL/GlutDemoApplication.h"
#include "btBulletDynamicsCommon.h"

class Pair
{
	public:
	Pair(){ m_value=m_dot=0;}
	Pair(btScalar value, btScalar dot){ m_value=value;m_dot=dot;}
	Pair operator*(btScalar k) { return Pair(k*m_value,k*m_dot);}
	Pair operator+(Pair p) { return Pair(p.m_value+m_value,p.m_dot+m_dot);}

	friend Pair operator*(btScalar k,Pair p) { return p*k;}
	btScalar m_value,m_dot;
};

class PendulumApplication : public GlutDemoApplication
{
public:
	PendulumApplication(void);
	~PendulumApplication(void);

	void initPhysics();

	void exitPhysics();



	virtual void clientMoveAndDisplay();
	virtual void displayCallback();
	virtual void clientResetScene();
	virtual void keyboardCallback(unsigned char key, int x, int y){if(key==27)exit(0);else DemoApplication::keyboardCallback(key,x,y);}
    virtual void mouseMotionFunc(int x, int y);

	//keep the collision shapes, for deletion/cleanup
	btAlignedObjectArray<btCollisionShape*>	m_collisionShapes;
	btBroadphaseInterface*	m_broadphase;
	btCollisionDispatcher*	m_dispatcher;
	btConstraintSolver*	m_solver;
	btDefaultCollisionConfiguration* m_collisionConfiguration;
	btRigidBody * m_pendulumBody;


    void Integrator_rk4();
	Pair f_rk4(Pair k);
	btVector3 pol2cart(btScalar r, btScalar theta);

    Pair m_theta;
    Pair m_r;
    btScalar m_dt;
};

